/*
	main.cpp
	Creation Date: March 26th, 2014
	Completion Date: March 28, 2014
	Created by: kiwidog (allenthinks.com/kiwidog.me)
	Copyright (c) kiwidoggie productions 2005-2014
	Selling source, or any product using this code is STRICTLY PROHIBITED without direct written permission from the author (kiwidog/A.Thomas)
	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
	KIND, EITHER EXPRESSED OR IMPLIED. ANY USE IS AT YOUR OWN RISK.

	Long Story Short: Check if your map files are "clean"

	Short story long: with the upcoming release date of Venice Unleashed comming soon(tm)
	I reversed the method that was checking for valid files, this source is a crappy piece of crap that should not be used in production!
	You will need to extract DICE's public key from the game executable to use this. It will NOT be provided nor, should it be redistributed.
	Here's a hint, search in a memory hex editor for "RSA1", "Digital Illusions CE AB" or just goto offset .rdata:020715A0 in the latest game
	and dump a size of 0x11B bytes. Theres your public key! You can dump using MHS (memoryhacking.com) or Cheat Engine, or just create a hook to dump it.
	Really I don't care, just get it yourself from the legal copy of the game. (If you just try going to that offset, the game is encrypted
	and required Origin(TM) to decrypt it. So run the game as you normally would in SP or a NON-PB server and dump using any of the tools.

	Or if you dumped the entire exe from memory to file, it will be around address 0x1C715A0.

	Good Luck, Have Fun
	-kiwidog
*/
#include <Windows.h>
#include <bcrypt.h>
#include <stdio.h>
#include <stdint.h>
#include <ntstatus.h>

#include <openssl/hmac.h>
#include <openssl/sha.h>

#pragma comment(lib, "Bcrypt.lib")
#ifdef _DEBUG
#pragma comment(lib, "libeay32MTd.lib")
#else
#pragma comment(lib, "libeay32MT.lib")
#endif

void fuscate(unsigned char* tocData, unsigned int tocDataLen, unsigned char*& output, unsigned int& outputLen)
{
	unsigned char* s_table = (unsigned char*)malloc(0x101);
	memset(s_table, 0, 0x101);

	memcpy(s_table, tocData + 0x128, 0x101);

	outputLen = tocDataLen - 0x22C;
	output = (unsigned char*)malloc(outputLen);
	memcpy(output, tocData + 0x22C, outputLen);

	for (unsigned int i = 0; i < outputLen; ++i)
	{
		output[i] ^= s_table[i % 0x101];
		output[i] ^= 0x7B;
	}
}

int VerifyVeniceSignature(FILE* p_file, FILE* p_keyFile)
{
	if (!p_file || !p_keyFile)
		return ERROR_BAD_ARGUMENTS;

	unsigned char* s_tocData = NULL;
	unsigned char* s_keyData = NULL;
	bool result = false;
	BCRYPT_KEY_HANDLE hKey;
	BCRYPT_ALG_HANDLE hAlgorithm;
	int(__stdcall** pPaddingInfo)(int, int, int);
	unsigned char* pbHash;
	unsigned int s_fileLength = 0;
	unsigned int s_tocLen = 0;
	// Read out the toc file
	fseek(p_file, 0, SEEK_END);
	s_fileLength = ftell(p_file);
	s_tocLen = s_fileLength;
	fseek(p_file, 0, SEEK_SET);

	// Allocate memory for the toc data
	s_tocData = (unsigned char*)malloc(s_fileLength);
	if (!s_tocData)
	{
		printf("err: could not allocate %d bytes.", s_fileLength);
		return -1;
	}

	// Read the toc data
	if (fread(s_tocData, 1, s_fileLength, p_file) != s_fileLength)
	{
		free(s_tocData);
		printf("err: the data read was not the length of the data.");
		return -1;
	}

	s_fileLength = 0; // Reset the file length
	fseek(p_keyFile, 0, SEEK_END);
	s_fileLength = ftell(p_keyFile);
	fseek(p_keyFile, 0, SEEK_SET);

	s_keyData = (unsigned char*)malloc(s_fileLength);
	if (!s_keyData)
	{
		printf("err: could not allocate %d bytes.", s_fileLength);
		return -1;
	}

	if (fread(s_keyData, 1, s_fileLength, p_keyFile) != s_fileLength)
	{
		free(s_tocData);
		free(s_keyData);
		printf("err: the data read was not the length of the data.");
		return -1;
	}

	NTSTATUS s_status; STATUS_INVALID_HANDLE;
	// Verify header magic
	uint32_t s_tocHeader = *(uint32_t*)s_tocData;
	if (*(uint32_t*)s_tocData == 0x01ced100)
	{
		hAlgorithm = NULL;
		hKey = NULL;
		result = false;

		// Open a new algorithm provider
		if (BCryptOpenAlgorithmProvider(&hAlgorithm, BCRYPT_RSA_ALGORITHM, 0, 0) >= 0)
		{
			if (BCryptImportKeyPair(hAlgorithm, 0, BCRYPT_RSAPUBLIC_BLOB, &hKey, s_keyData, 0x11B, 0) >= 0)
			{
				// Un-xor the file
				unsigned char* s_unfuscatedData = NULL;
				uint32_t s_unfuscatedDataLen = 0;

				fuscate(s_tocData, s_tocLen, s_unfuscatedData, s_unfuscatedDataLen);

				// TODO: Reverse that other function
				const unsigned char* s_key = (const unsigned char*)"Powered by Frostbite \\o/ EA Digital Illusions CE AB";
				uint32_t s_keyLen = strlen((const char*)s_key);
				
				uint32_t s_mdLen = 20;
				pbHash = (unsigned char*)malloc(s_mdLen);
				memset(pbHash, 0, s_mdLen);

				// So its actually not the toc data, its after you un-xor everything. Its the superbundle data that the hash is calculated...
				HMAC(EVP_sha1(), s_key, s_keyLen, s_unfuscatedData, s_unfuscatedDataLen, pbHash, &s_mdLen);
				//sub_494DC0(NULL, NULL, NULL, "Powered by Frostbite \\o/ EA Digital Illusions CE AB", 33);
				BCRYPT_PKCS1_PADDING_INFO s_paddingInfo;
				s_paddingInfo.pszAlgId = BCRYPT_SHA1_ALGORITHM;

				s_status = BCryptVerifySignature(hKey, &s_paddingInfo, pbHash, 0x14, (s_tocData + 8), 0x100, BCRYPT_PAD_PKCS1);
				switch (s_status)
				{
				case STATUS_SUCCESS:
					result = true;
					break;
				default:
					result = false;
					break;
				}
				BCryptDestroyKey(hKey);
				free(s_tocData);
				free(s_keyData);
				free(s_unfuscatedData);
			}
			BCryptCloseAlgorithmProvider(hAlgorithm, 0);
		}
	}
	else
		return true;

	return result;
}

int main(int argc, char* argv[])
{
	if (argc < 1)
	{
		printf("usage: venicecrypttest <toc file> <key file>\r\n");
		return 0;
	}
	else if (argc == 3)
	{
		FILE* s_tocFileHandle = fopen(argv[1], "rb");
		FILE* s_keyFileHandle = fopen(argv[2], "rb");
		printf("signature validation passed: %d", VerifyVeniceSignature(s_tocFileHandle, s_keyFileHandle));
		fclose(s_tocFileHandle);
		fclose(s_keyFileHandle);
	}
	return 0;
}